
/* Web Polygraph       http://www.web-polygraph.org/
 * (C) 2003-2006 The Measurement Factory
 * Licensed under the Apache License, Version 2.0 */

#ifndef POLYGRAPH__XSTD_H_SSTREAM_H
#define POLYGRAPH__XSTD_H_SSTREAM_H

#if defined(HAVE_SSTREAM)
#   include <sstream>
#elif defined(HAVE_STRSTREAM)
#	include <stringstream>
#elif defined(HAVE_STRSTREAM_H)
#	include <stringstream.h>
#elif defined(HAVE_STRSTREA_H) /* MS file name limit */
#	include <strstrea.h>
#endif

class ofixedstream: public ostringstream {
	public:
		ofixedstream(char_type *buffer, streamsize size) {
			rdbuf()->pubsetbuf(buffer, size);
		}
};

#ifdef STEAMBUFFER_BASED_SKELETON
// from http://www.velocityreviews.com/forums/showpost.php?p=1532770&postcount=2
class stringbuf: std::streambuf
{
	public:
		enum { s_size = 1024 };
		stringbuf() { setp(m_buf, m_buf + s_size); }
		std::string str() const { return std::string(pbase(), pptr()); }
		void str(std::string const &s) {
			std::copy(s.begin(), s.end(), m_buf);
		}

	private:
		char m_buf[s_size];
};

class ostringstream_replacement: private virtual stringbuf, std:stream
{
	ostringstream_replacement(): std:stream(static_cast<std::streambuf*>(this)) {}
};
#endif


// stringstream does not require freezing
inline
void streamFreeze(ostringstream &, bool) {
}

#endif
